'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_Component) {
  _inherits(Input, _Component);

  // Lifecycle Functions

  function Input(props) {
    _classCallCheck(this, Input);

    var _this = _possibleConstructorReturn(this, (Input.__proto__ || Object.getPrototypeOf(Input)).call(this, props));

    _this.state = {
      value: _this.props.defaultValue
    };
    return _this;
  }

  // Utility FUnctions

  _createClass(Input, [{
    key: 'value',
    value: function value() {
      return this.state.value;
    }

    // Hanlder Funcitons

  }, {
    key: 'handleChange',
    value: function handleChange(event) {
      var _this2 = this;

      var initialValue = this.state.value;
      this.setState({
        value: event.target.value
      }, function () {
        if (initialValue !== _this2.state.value) {
          _this2.handleChangeCallbacks(event);
        }
      });
    }
  }, {
    key: 'handleChangeCallbacks',
    value: function handleChangeCallbacks(event) {
      this.props.onChange(event);
      this.props.onFormChange(event);
    }

    // Render Helper Functions

  }, {
    key: 'inputType',
    value: function inputType() {
      if (this.props.password) return 'password';else return '';
    }

    // Render Functions

  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement('input', {
        onChange: this.handleChange.bind(this),
        placeholder: this.props.placeholder,
        value: this.state.value,
        type: this.inputType()
      });
    }
  }]);

  return Input;
}(_react.Component);

Input.defaultProps = {
  defaultValue: null,
  onChange: function onChange() {}
};


Input.propTypes = {
  name: _react2.default.PropTypes.string.isRequired,
  onFormChange: _react2.default.PropTypes.func
};

exports.default = Input;